# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $EmailVirtUser = "/etc/virtusertable";
my $Lockdir = "/etc/locks";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_add_vsite
# adds a vsite to the access database, format:  "host/network/domain RELAY"
# This will stop mail from being sent to multiple sites for same user.
# Arguments: fully quallified name of vsite
# Return value: status string of the form "1288 Cheap irony not supported
#   in this release."
{
        my ($new_vsite) = @_;
	my ($notend) = 1;
	my ($vsite_sec_exists) = 0;
	my($lockfile) = "$Lockdir/virtusertable";

# Default system users needed since we now do catch-all.
	my %MailSystemUsers  = ("MAILER-DAEMON",   1,
            "postmaster",      1,
            "sys",             1,
            "admin",             1,
	    "root",            1);
	my %aliases;
	foreach (sort keys %MailSystemUsers) {
	    my $alias = $_."\@".$new_vsite;
	    $aliases{$alias} = $_;
        }
	my $ret = mail_virtuser_add_alias(%aliases);


        open (DBWRITE, "> $lockfile")
          || return "4064 Cannot write relay access database: $!";
        open (DBREAD, "$EmailVirtUser")
          || return "4065 Cannot read relay access database: $!";

        while (<DBREAD>)
        {
		if ($notend)
		{
	                if (/Mail rejected due to possible SPAM/o)
	                {
			       # not for us...
			       print DBWRITE;
	                }
	                elsif (/^(\S+)\s+RELAY/o)
	                {
			       print DBWRITE;
	                }
	                elsif (/^# Define Virtual Site default behavior/o)
			{
			        $vsite_sec_exists = 1;
			        print DBWRITE;
			}
	                elsif (/^# Put custom additions below/o)
	                {
			        if (!$vsite_sec_exists)
				{
				    print DBWRITE "# Define Virtual Site default behavior (Do not change/remove this line).\n"; 
				}
			        # Now add all our new virtual host entries
 			        print DBWRITE "\@$new_vsite  \t  error\n";          
	                        print DBWRITE "# Put custom additions below (Do not change/remove this line).\n";
	                        $notend = 0;
	                }
			else
			{
				print DBWRITE;
			}
		}
                else
                {
                        print DBWRITE;
                }
        }

        close DBWRITE;
        close DBREAD;

	unless (-w $EmailVirtUser) {
	  # For some reason, we can't write to this file...eek!
	  unlink("$lockfile");
	  return "4066 Cannot write relay access database: $!";
	}
	    

	# Now that the flat files have been built, make the database file
	print STDERR "$MakeMap_cmd hash $EmailVirtUser.db < $lockfile\n" 
	  if ($Debug);
	system("$MakeMap_cmd hash $EmailVirtUser.db < $lockfile >>$Sauce_log 2>&1")
	  && return "4067 Cannot build virtual alias database: $!";

	# keep the text version around, too
	rename("$lockfile","$EmailVirtUser") 
	  || return "4068 Cannot unlock relay access database: $!";

	return "2020 Email server alias added successfully";
}


1;
