# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $EmailVirtUser = "/etc/virtusertable";
my $Lockdir = "/etc/locks";
my $MakeMap_cmd = "/usr/bin/makemap";
my $Sauce_log = "/var/cobalt/sauce.log";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_del_vsite
# Removes vsite from sendmail's access database files
# Disables  email default behavior
# Arguments: name of new vsite
# Return value: string of the form "3100 IiinnNPPuuuTtt"
{
        my ($vsite) = @_;
        my ($notend) = 1;
	my ($lockfile) = "$Lockdir/virtusertable";

        # Default system users needed since we now do catch-all.
	my %MailSystemUsers  = ("MAILER-DAEMON",   1,
            "postmaster",      1,
            "sys",             1,
            "admin",           1,
	    "root",            1);
	my %aliases;
	foreach (sort keys %MailSystemUsers) {
	    my $alias = $_."\@".$vsite;
	    $aliases{$alias} = $_;
        }
	my $ret = mail_virtuser_del_alias(%aliases);


        return "4069 Cannot lock relay access database: $!" if ( -e "$lockfile" );

        open (DBWRITE, "> $lockfile")
	    || return "4070 Cannot write relay access database: $!";
        open (DBREAD, "$EmailVirtUser")
	    || return "4071 Cannot read relay access database: $!";
        while (<DBREAD>)
        {
		if ($notend)
		{
	                if (/Mail rejected due to possible SPAM/o && $notend)
	                {
	                        print DBWRITE;
	                }
	                elsif (/^(\S+)\s+RELAY/o)
	                {
 			        print DBWRITE;
	                }
	                elsif (/^\@$vsite/o)
			{
			    # Do nothing, this will delete the entry
			}
	                elsif (/^# Put custom additions below/o)
	                {
	                        print DBWRITE "# Put custom additions below (Do not change/remove this line).\n";

	                        $notend = 0;
	                }
			else
			{
				print DBWRITE;
			}
		}
                else
                {
                        print DBWRITE;
                }
        }

        close DBWRITE;
        close DBREAD;

	unless (-w $EmailVirtUser) {
	  unlink("$lockfile");
	  return "4072 Cannot write relay access database: $!";
	}

	# Build the database version of the access database
        print STDERR "$MakeMap_cmd hash $EmailVirtUser.db < $lockfile" if ($Debug);
        system("$MakeMap_cmd hash $EmailVirtUser.db < $lockfile>>$Sauce_log 2>&1")
          && return "4073 Cannot unlock relay access database: $!";

	# keep the text version, too
	rename("$lockfile", "$EmailVirtUser") || return 0;
        Cobalt::Email::mail_sendmail_hup();

	return "2021 Email server alias removed successfully";
}


1;
