# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_virtuser_del_alias
# Deletes a hash of login name and fully qualified email addresses or @domains
# Arguments: hash  (alias => user)
# Return value: string like "2000 Mmm, smells like BBQ and beer"
# Side effects: Rebuilds /etc/virtusertable.db from modified /etc/virtusertable
{
	my(%delAlias) = @_;

	# -----------------------------------
	# get the lock for /etc/virtusertable
	# -----------------------------------
	get_virtuser_lock()
	    || return "4127 Could not modify email alias list";
	
	my(%aliases) = Cobalt::Email::mail_virtuser_list_alias();
	my(%routes) = Cobalt::Email::mail_virtuser_list_route();
	my(%catchall) = Cobalt::Email::mail_virtuser_list_catchall();


	my($alias);

	foreach $alias (keys %delAlias)
	{
	    delete $aliases{$alias};
	}

	if (!Cobalt::Email::mail_build_virtusertable(\%aliases, \%routes, \%catchall)) {
	    # --------------------------------------
	    # release the lock for /etc/virtusertable
	    # --------------------------------------
	    release_virtuser_lock();	    
	    return "4128 Could not modify email alias list";
	}

	# --------------------------------------
	# release the lock for /etc/virtusertable
	# --------------------------------------
	release_virtuser_lock();
	return "2031 Email virtual users removed successfully";
}


1;
