# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Email.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Email.pm.  Changes made here will be lost.
package Cobalt::Email;

sub mail_virtuser_del_route
# Deletes a hash of "domain" and "fqdn to route to"
# Arguments: hash  (domain => fqdn to route to)
# Return value: string like "2000 Mmm.. forbidden dounut..."
# Side effects: Rebuilds /etc/virtusertable.db from modified /etc/virtusertable
{
	my(%del_route) = @_;

	# -----------------------------------
	# get the lock for /etc/virtusertable
	# -----------------------------------
	get_virtuser_lock()
	    || return "4132 Could not modify email alias list";
	
	my(%aliases) = Cobalt::Email::mail_virtuser_list_alias();
	my(%routes) = Cobalt::Email::mail_virtuser_list_route();
	my(%catchall) = Cobalt::Email::mail_virtuser_list_catchall();
	my($r);

	foreach $r (keys %del_route)
	{
	    delete $routes{$r};
	}

	if (!Cobalt::Email::mail_build_virtusertable(\%aliases, \%routes, \%catchall)) {
	    # --------------------------------------
	    # release the lock for /etc/virtusertable
	    # --------------------------------------
	    release_virtuser_lock();
	    return "4133 Could not modify email alias list";
	}


	# --------------------------------------
	# release the lock for /etc/virtusertable
	# --------------------------------------
	release_virtuser_lock();

	return "2034 Email virtual users removed successfully";
}


1;
