# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Legato.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Hostfile = "/etc/hosts";
my $Lockdir = "/etc/locks";
my $Networker_config = "/etc/sysconfig/legato";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Legato.pm.  Changes made here will be lost.
package Cobalt::Legato;

use strict;

# legato_set_servername
#
# Sets the name of the legato server in the legato config file
# and in /etc/hosts
#
# args: dns name, ip address
# returns: the usual
#
sub legato_set_serveraddr {
  my ($dnsname, $ipaddr) = @_;

  if (! Cobalt::Netutil::netutil_test_ipaddr($ipaddr)) {
    return "4343 $ipaddr is not a valid IP address.";
  }

  if (! Cobalt::Netutil::netutil_test_domainname($dnsname)) {
    return "4344 $dnsname is not a valid hostname.";
  }

  # edit the legato config file
  open(CONF, $Networker_config);
  open(LOCK, ">$Lockdir/legato.conf");
  my $founddns = 0;
  my $foundip = 0;
  while (<CONF>) {
    if (/^LEGATO_SERVER/) {
      print LOCK "LEGATO_SERVER=$dnsname\n";
      $founddns = 1;
    } elsif (/^LEGATO_IP/) {
      print LOCK "LEGATO_IP=$ipaddr\n";
      $foundip = 1;
    } else {
      print LOCK $_;
    }
  }
  # add the settings at the end even if they weren't found
  if (! $founddns) {
    print LOCK "LEGATO_SERVER=$dnsname\n";
  }
  if (! $foundip) {
    print LOCK "LEGATO_IP=$ipaddr\n";
  }
  close(LOCK);
  close(CONF);
  rename("$Lockdir/legato.conf", $Networker_config);

  # edit the /etc/hosts file
  open(HOSTS, $Hostfile);
  open(LOCK, ">$Lockdir/hosts");
  my $foundhost = 0;
  while (<HOSTS>) {
    if (/\# legato server/) {
      print LOCK "$ipaddr\t$dnsname\t# legato server\n";
      $foundhost = 1;
    } else {
      print LOCK $_;
    }
  }
  if (! $foundhost) {
    print LOCK "$ipaddr\t$dnsname\t# legato server\n";
  }
  close(LOCK);
  close(HOSTS);
  rename("$Lockdir/hosts", $Hostfile);
  
  return "2060 Legato server name updated.";
}


1;
