# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Lockdir = "/etc/locks";
my $Majordomo_aliases = "/etc/aliases.majordomo";
my $Majordomo_dir = "/usr/local/majordomo";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_delete
# Delete the specified lists
# Arguments: lists to be deleted
# Return value: number of lists actually deleted
# Side effects: remove files belonging to the lists
{
    my (@lists, $lock);
    while ($_ = shift) {
        # cannot send mail during installation or sysreset
        # kludge..never do it -- gsri
#       next unless -f "$Majordomo_dir/lists/$_.config";
	push @lists, $_;
	tr[A-Z][a-z];		# lowercase the characters
	unlink "$Majordomo_dir/lists/$_.intro";
	unlink "$Majordomo_dir/lists/$_.info";
	unlink "$Majordomo_dir/lists/$_.auto";
	unlink "$Majordomo_dir/lists/$_.open";
	unlink "$Majordomo_dir/lists/$_.closed";
	unlink "$Majordomo_dir/lists/$_.config";
    }
    return $lock if (($lock = Cobalt::List::lock_aliases()) !~ /^2/);
    open( ALIAS, "$Majordomo_aliases") ||
	Cobalt::List::abort("4409 Cannot read /etc/aliases.majordomo: $!");
    open( ALIAS_NEW, "> $Lockdir/aliases.majordomo") ||
	Cobalt::List::abort("4410 Cannot write to /etc/locks/aliases.majordomo: $!");
    my $line;
    while ($line = <ALIAS>) {
	if ($line =~ /^owner-(\S+):/ || $line =~ /^(\S+)-list:/ ||
	    $line =~ /^(\S+)-request:/ || $line =~ /^(\S+)-approval:/ ||
	    $line =~ /^(\S+):/) {
	    print ALIAS_NEW $line unless (grep /^$1$/, @lists);
	}
    }
    close ALIAS_NEW;
    close ALIAS;
    unlink map "$Majordomo_dir/lists/$_", @lists;
    move("$Lockdir/aliases.majordomo", $Majordomo_aliases) or
	abort("4411 Cannot move /etc/locks/aliases.majordomo: $!");
    unlock_aliases();
    return("2070 Lists deleted successfully");
}


1;
