# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from List.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $MainGroup = "home";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/List.pm.  Changes made here will be lost.
package Cobalt::List;

sub list_sites_modify
# Modify a list for a particular site
# Arguments: site group name, old listname, new listname, new members
# Return value: usual error string
# Side effects: read side effects of list_modify
{
    my ($group, $oldlist, $list, @members) = @_;
    my $ret;
    $list =~ tr[A-Z][a-z];	# lowercase the characters
    $oldlist =~ tr[A-Z][a-z];	# lowercase the characters
    return $ret if (($ret = list_modify("${oldlist}_${group}",
					"${list}_${group}", @members)) !~ /^2/);

    # i don't really like this code here -- gsri
    # modify entries in virtusertable
    my $fqdn = ($group eq $MainGroup) ?
	netutil_get_fulldomain() : (vsite_get_bygroup($group))[1];
    my(%aliases) = mail_virtuser_list_alias();
    my(%routes) = mail_virtuser_list_route();

    delete $aliases{"${oldlist}\@${fqdn}"};
    delete $aliases{"${oldlist}-list\@${fqdn}"};
    delete $aliases{"${oldlist}-approval\@${fqdn}"};
    delete $aliases{"${oldlist}-request\@${fqdn}"};
    delete $aliases{"owner-${oldlist}\@${fqdn}"};
    $aliases{"${list}\@${fqdn}"} = "${list}_${group}";
    $aliases{"${list}-list\@${fqdn}"} = "${list}_${group}-list";
    $aliases{"${list}-approval\@${fqdn}"} = "${list}_${group}-approval";
    $aliases{"${list}-request\@${fqdn}"} = "${list}_${group}-request";
    $aliases{"owner-${list}\@${fqdn}"} = "owner-${list}_${group}";
    mail_build_virtusertable(\%aliases, \%routes) or
	return "4493 Cannot modify virtual aliases table";

    return ("2078 List modified successfully: $oldlist -> $list");
}


1;
