# This autoloader file was built automatically by 
# /usr/local/sbin/autoize from Vacation.pm

# Copyright 1998 Cobalt Networks (http://www.cobaltnet.com)

use strict;
### START HARDCODED PATHS
my $Vaca_dir = "/var/vacation";
my $Debug = (-e "/etc/DEBUG") ? 1 : 0;
$^W = ($Debug ||= 0);
### END HARDCODED PATHS

# NOTE: Derived from /usr/lib/perl5/site_perl/Cobalt/Vacation.pm.  Changes made here will be lost.
package Cobalt::Vacation;

sub vacation_set_message
# Set the message being used by the vacation program
# Arguments: user name, the message in a big string
#   if the string is "", then the file is deleted.
# Return value: the usual status string
# Side effects: creates the message file
{
    if (! -e $Vaca_dir)
    {
	mkdir($Vaca_dir,01777) ;
	chmod(01777,$Vaca_dir);
    }
    my ($user,$message) = @_;
    my $messagefile = "$Vaca_dir/$user.msg";


    # Prevent Eval hackery attempt
    if ( ! -f $messagefile || -l $messagefile) {
	unlink $messagefile;
    }

    if ($message)
    {
	open(VACA,">$messagefile") ||
	    return("4181 Cannot write auto-reply message for $user: $!");
	print VACA $message;

	close VACA;

	my $uid = (getpwnam($user))[2];
	my $gid = (getgrnam("mail"))[2];
	if ($uid && $gid)
	{
	    # might not be for a real user
	    chown($uid,$gid,$messagefile)
		|| return "3018 Could not set owner $uid for message $messagefile: $!";
	}

	# needs to be vacation.pl readable
	chmod 0640,$messagefile;

	return "2327 Auto-reply message set in $messagefile";
    }
    else
    {
	unlink($messagefile) if (-e $messagefile);
	return "2328 $user now has no message file";
    }
}


1;
